import AsyncShowComponent from './vue-async-show.vue'

let AsyncShow = {}
// https://cn.vuejs.org/v2/api/#Vue-extend
AsyncShow.install = function(Vue, options) {

  var opt = {
    duration: 3000
  }
  for (var i in options) {
    opt[i] = options[i]
  }
  Vue.prototype.$asyncshow = function(message, option) {
    if (typeof option == 'object') {
      for (var i in option) {
        opt[i] = option[i]
      }
    }
    const AsyncShowController = Vue.extend(AsyncShowComponent)
    var instance = new AsyncShowController().$mount(document.createElement('div'))
    instance.message = message
    instance.visible = true
    document.body.appendChild(instance.$el)
    setTimeout(() => {
      instance.visible = false
      document.body.removeChild(instance.$el)
    }, opt.duration)
  }
  Vue.prototype.$asyncshow['show'] = function(message, option) {
    Vue.prototype.$asyncshow(message, option)
  }
  Vue.prototype.$asyncshow['success'] = function(message, option) {
    Vue.prototype.$asyncshow(message, option)
  }
  Vue.prototype.$asyncshow['info'] = function(message, option) {
    Vue.prototype.$asyncshow(message, option)
  }
  Vue.prototype.$asyncshow['error'] = function(message, option) {
    Vue.prototype.$asyncshow(message, option)
  }
}
if (window.Vue) {
  Vue.use(AsyncShow)
}

export default AsyncShow